-- INFORMIX Dynamic 4GL Demonstration
--
-- @(#)$Id: d4_main.4gl,v 1.7 1998/08/04 23:21:58 jleffler Exp $
--
-- $Product: INFORMIX Dynamic 4GL Demonstration Version 2.00.UC8 (1998-08-25) $

GLOBALS "d4_globals.4gl"

MAIN

    DEFER INTERRUPT

--# IF TRUE THEN
--#     OPTIONS HELP FILE "helpdemo.42h"
--# ELSE
        OPTIONS HELP FILE "helpdemo.iem"
--# END IF

    LET print_option = "s"
--# CALL fgl_init4js() --Init for 4js functions
--# LET fulldemo = (FGL_GETENV("FGLPROFILE") IS NOT NULL) AND fgl_fglgui()

    # Pre-initialize list of states and list of stock items
    CALL get_states()
    CALL get_stocks()

--#-- Add an INFORMIX logo
--# IF fulldemo THEN
--#     OPEN WINDOW lwin AT 22,83 WITH 2 ROWS, 23 COLUMNS
--#          ATTRIBUTE(BLINK,BOLD,FORM LINE 1)
--#     OPEN FORM logo FROM "logo"
--#     DISPLAY FORM logo ATTRIBUTE(BLINK,BOLD)
--#     DISPLAY "logoblu3.bmp" TO F1 ATTRIBUTE(BLINK,REVERSE)
--#     CURRENT WINDOW IS SCREEN
--# END IF

    CALL ring_menu()
    MENU "MAIN"
        COMMAND "Customer" "Enter and maintain customer data" HELP 101
            CALL customer()
            CALL ring_menu()
        COMMAND "Orders" "Enter and maintain orders" HELP 102
            CALL orders()
            CALL ring_menu()
        COMMAND "Stock" "Enter and maintain stock list" HELP 103
            CALL stock()
            CALL ring_menu()
        COMMAND "Reports" "Print reports and mailing labels" HELP 104
            CALL reports()
            CALL ring_menu()
        COMMAND KEY("!")
            CALL bang()
            CALL ring_menu()
            NEXT OPTION "Customer"
        COMMAND KEY("X")
            CALL demo()
            CALL ring_menu()
            NEXT OPTION "Customer"
        COMMAND KEY ("E", INTERRUPT) "Exit" "Exit program and return to operating system" HELP 105
            CLEAR SCREEN
            EXIT PROGRAM
    END MENU

END MAIN


FUNCTION bang()

    DEFINE cmd CHAR(80),
           x CHAR(1)

    CALL clear_menu()
      LET x = "!"
      WHILE x = "!"
         PROMPT "!" FOR cmd
         RUN cmd
         PROMPT "Type RETURN to continue." FOR CHAR x
      END WHILE

END FUNCTION {bang}


FUNCTION mess(str, mrow)

    DEFINE str CHAR(80),
           mrow SMALLINT

    DISPLAY " ", str CLIPPED AT mrow,1
    SLEEP 3
    DISPLAY "" AT mrow,1

END FUNCTION {mess}


FUNCTION ring_menu()

--#     IF NOT fulldemo THEN
            DISPLAY "---------------------------------------   ",
                    "Type Control-W for MENU HELP   -----" AT 4,2 ATTRIBUTE(BLACK)
--#     END IF

END FUNCTION {ring_menu}


FUNCTION unring_menu()

--#     IF NOT fulldemo THEN
            DISPLAY "---------------------------------------   ",
                    "                               -----" AT 4,2 ATTRIBUTE(BLACK)
--#     END IF

END FUNCTION {unring_menu}


FUNCTION clear_menu()

    DISPLAY "" AT 1,1
    DISPLAY "" AT 2,1

END FUNCTION {clear_menu}


FUNCTION get_states()

    DECLARE c_state CURSOR FOR
        SELECT * FROM state
        ORDER BY sname
    LET state_cnt = 1
    FOREACH c_state INTO p_state[state_cnt].*
        LET state_cnt = state_cnt + 1
        IF state_cnt > 50 THEN
            EXIT FOREACH
        END IF
    END FOREACH
    LET state_cnt = state_cnt - 1

END FUNCTION {get_states}


FUNCTION get_stocks()

    DECLARE stock_list CURSOR FOR
        SELECT stock_num, manufact.manu_code,
                manu_name, description, unit_price, unit_descr
        FROM stock, manufact
        WHERE stock.manu_code = manufact.manu_code
        ORDER BY stock_num
    LET stock_cnt = 1
    FOREACH stock_list INTO p_stock[stock_cnt].*
        LET stock_cnt = stock_cnt + 1
        IF stock_cnt > 30 THEN
            EXIT FOREACH
        END IF
    END FOREACH
    LET stock_cnt = stock_cnt - 1

END FUNCTION {get_stocks}
